//Starting Behavior/Act Schema Parser 

float dist_act;
float marge_dist;
float marge_angle;

//Defining behavior sfTracking


 /* for reference pointers */

static int _sfleft = TURN_LEFT; 
static int _sfright = TURN_RIGHT; 
static int _sfbackward = DECEL; 
static int _sfforward = ACCEL; 
static int _sfspeed = ASPEED; 




/* Starting code for behavior sfTracking  */


void sfTracking_update();
void sfTracking_setup();

/* global vars for update fn */
static float emergencia;
static float too_fast;
static float too_slow;
static float massa_angle;
static float g__0;
static float ant__1;
static float marge_parada;
static float ant__2;
static float esquerra;
static float mod__3;
static float ant__4;
static float dreta;
static float mod__5;
static float ant__6;
static float e_massa_angle;
static float g__7;
static float ant__8;
static float ant__9;
static float e_esquerra;
static float mod__10;
static float ant__11;
static float e_dreta;
static float mod__12;
static float ant__13;
static float e_massa_prop;
static float mod__14;
static float ant__15;
static float e_massa_lluny;
static float mod__16;
static float ant__17;

behavior
_beh_sfTracking = {"sfTracking",
    sfTracking_setup, /* setup function */
    sfTracking_update, /* body function */
    2, /* number of params */
    {sfFLOAT, sfFLOAT},
    10, /* number of rules */
    {{"rule__0", &ant__1, &_sfspeed, &g__0},
     {"rule__1", &ant__2, &_sfspeed, &marge_parada},
     {"rule__2", &ant__4, &_sfleft, &mod__3},
     {"rule__3", &ant__6, &_sfright, &mod__5},
     {"rule__4", &ant__8, &_sfspeed, &g__7},
     {"rule__5", &ant__9, &_sfspeed, &marge_parada},
     {"rule__6", &ant__11, &_sfleft, &mod__10},
     {"rule__7", &ant__13, &_sfright, &mod__12},
     {"rule__8", &ant__15, &_sfleft, &mod__14},
     {"rule__9", &ant__17, &_sfright, &mod__16}
    }
};
behavior *sfTracking = &_beh_sfTracking;



void
sfTracking_setup (beh_params _params) { 
   float c_dist = _params[0].f;
   float c_velocitat = _params[1].f;

		distancia_a_mantenir = c_dist;	
		velocitat_a_mantenir = c_velocitat;
	}

/* global vars for update fn */



void
sfTracking_update(beh_params _params)
{
   float c_dist = _params[0].f;
   float c_velocitat = _params[1].f;

		// Inicialitzaci de parmetres

		marge_dist = dist_sens*c_dist;
		marge_angle = angle_sens*360;
		marge_parada = parada_sens*c_velocitat;

		// Clcul del contorn

		c_calcul_contorn();

		// Parametres de lgica difusa

		too_fast = up_straight(sfTargetVel(), c_velocitat, c_velocitat+50);
		too_slow = straight_down(sfTargetVel(), c_velocitat-50, c_velocitat);

		massa_angle = straight_down(angle_cami_control,-60.0,-20.0);
		massa_angle = f_or(massa_angle,up_straight(angle_cami_control,20.0,60.0));

		esquerra = up_straight(angle_cami_control,0.0,marge_angle);
		dreta = straight_down(angle_cami_control,0.0,-marge_angle);

		// Parametres emergncia de lgica difusa

		dist_act = distancia_control;

		emergencia = (float)((dist_act>(c_dist*const_dist_emergencia))||(modul(angle_control)>angle_control_emergencia)||(llNumPunts(llista)==0));
		emergencia = f_or(emergencia,straight_down(r_reg,r_min_emergencia,r_max_emergencia));
		//emergencia = 0.0;

		// if (emergencia==1.0) sfSMessage("Emergencia!");

		e_massa_prop = up_straight(c_dist-dist_act,0.0,marge_dist);
		e_massa_lluny = straight_down(c_dist-dist_act,-marge_dist,0.0);

		if (!seguir_dreta)
		{
			e_massa_lluny = up_straight(c_dist-dist_act,0.0,marge_dist);
			e_massa_prop = straight_down(c_dist-dist_act,-marge_dist,0.0);
		}
		
		e_massa_angle = straight_down(angle_control,-60.0,-20.0);
		e_massa_angle = f_or(e_massa_angle,up_straight(angle_control,20.0,60.0));

		e_esquerra = up_straight(angle_control,0.0,marge_angle);
		e_dreta = straight_down(angle_control,0.0,-marge_angle);

		// Monitoritzar variables
		
		c_monitoritzar(monitoritzacio);
		c_visualitzar();
	 /* Begin activity section */
   c_act_v = c_act_t = 0.0;
    c_act_t = 1.0;
    c_act_v = 1.0;
    g__0 = c_velocitat;
    ant__1 = f_and(f_not(emergencia),f_and(f_or(too_fast,too_slow),f_not(massa_angle)));
    ant__2 = f_and(f_not(emergencia),massa_angle);
    mod__3 = sfVSLOWLY;
    ant__4 = f_and(f_not(emergencia),esquerra);
    mod__5 = sfVSLOWLY;
    ant__6 = f_and(f_not(emergencia),dreta);
    g__7 = c_velocitat;
    ant__8 = f_and(emergencia,f_and(f_or(too_fast,too_slow),f_not(e_massa_angle)));
    ant__9 = f_and(emergencia,e_massa_angle);
    mod__10 = sfVSLOWLY;
    ant__11 = f_and(emergencia,e_esquerra);
    mod__12 = sfVSLOWLY;
    ant__13 = f_and(emergencia,e_dreta);
    mod__14 = sfVSLOWLY;
    ant__15 = f_and(emergencia,f_and(e_massa_prop,f_not(e_massa_angle)));
    mod__16 = sfVSLOWLY;
    ant__17 = f_and(emergencia,f_and(e_massa_lluny,f_not(e_massa_angle)));
}


/* Ending code for behavior sfTracking  */


//Ending Behavior/Act Schema Parser
