/* ************** */
/* Fitxer sonar.h */
/* ************** */

// Funcions utilitzades per controlar els sonars

#ifndef _SONAR_H
#define _SONAR_H

// Funcions s_actualitzar

void s_actualitzar (void);
void s_actualitzar_d (void);
void s_actualitzar_e (void);
void s_actualitzar_f (void);

// Funcions s_maxim_x

int s_maxim (void);
int s_maxim_d (void);
int s_maxim_e (void);
int s_maxim_f (void);

// Funcions s_posar_maxim_x

void s_posar_maxim_l (int maxim);
void s_posar_maxim_f (int maxim);

// Funcions s_elements_x

int s_elements (void);
int s_elements_d (void);
int s_elements_e (void);
int s_elements_f (void);

// Funcions s_x_x, s_y_x

float s_x (int i);
float s_y (int i);

float s_x_d (int i);
float s_y_d (int i);

float s_x_e (int i);
float s_y_e (int i);

float s_x_f (int i);
float s_y_f (int i);

// Funcions s_dist_x

float s_dist (int i);
float s_dist_d (int i);
float s_dist_e (int i);
float s_dist_f (int i);

// Funcions s_angle_x

float s_angle (int i);
float s_angle_d (int i);
float s_angle_e (int i);
float s_angle_f (int i);

// Funcions s_total_quadre_x

int s_total_quadre (float x0, float y0, float x1, float y1);
int s_total_quadre_d (float x0, float y0, float x1, float y1);
int s_total_quadre_e (float x0, float y0, float x1, float y1);
int s_total_quadre_f (float x0, float y0, float x1, float y1);

// Funcions s_dist_min_x

int s_dist_min_d (void);
int s_dist_min_e (void);
int s_dist_min_f (void);
int s_dist_min (void);

// Funcions s_dist_max_x

int s_dist_max (void);
int s_dist_max_d (void);
int s_dist_max_e (void);
int s_dist_max_f (void);

// Funcions s_elements_cercle_x

int s_total_cercle (float radi);
int s_total_cercle_d (float radi);
int s_total_cercle_e (float radi);
int s_total_cercle_f (float radi);

#endif